﻿namespace ArcXP
{
	using System;
	using System.Collections.Generic;
	using System.ComponentModel;
	using System.Data;
	using System.Drawing;
	using System.Text;
	using System.Windows.Forms;
	using System.Runtime.InteropServices;
	using System.Diagnostics;
	using System.IO;

	public partial class Derp : Form
	{
		public Derp()
		{
			InitializeComponent();
		}

		private void Derp_Load(object sender, EventArgs e)
		{
			textBoxPWIPath.Text = Properties.Settings.Default.InstallationPath;
		}

		private void buttonStartPatcher_Click(object sender, EventArgs e)
		{
			string dir = textBoxPWIPath.Text + @"\patcher\";
			string path = dir + "patcher.exe";

			if (!File.Exists(path))
			{
				MessageBox.Show("PWI Patcher could not be found");
				return;
			}

			Process proc = new Process();
			proc.StartInfo.WorkingDirectory = dir;
			proc.StartInfo.FileName = path;
			proc.StartInfo.Arguments = "arc:1";

			proc.Start();
		}

		private void buttonStartPWI_Click(object sender, EventArgs e)
		{
			string dir = textBoxPWIPath.Text + @"\element\";
			string path = dir + "elementclient.exe";

			if (!File.Exists(path))
			{
				MessageBox.Show("PWI could not be found");
				return;
			}

			Process proc = new Process();
			proc.StartInfo.WorkingDirectory = dir;
			proc.StartInfo.FileName = path;
			proc.StartInfo.Arguments = "startbypatcher arc:1";
			
			proc.Start();
		}

		private void buttonSelectFolder_Click(object sender, EventArgs e)
		{
			using (FolderBrowserDialog folderDialog = new FolderBrowserDialog())
			{
				if ( Directory.Exists(textBoxPWIPath.Text) )
					folderDialog.SelectedPath = textBoxPWIPath.Text;

				if (folderDialog.ShowDialog() == DialogResult.OK)
				{
					textBoxPWIPath.Text = folderDialog.SelectedPath;
					SaveInstallPath();
				}
			}
		}

		private void textBoxArcPath_KeyUp(object sender, KeyEventArgs e)
		{
			SaveInstallPath();
		}

		private void SaveInstallPath()
		{
			Properties.Settings.Default["InstallationPath"] = textBoxPWIPath.Text;
			Properties.Settings.Default.Save();
		}
	}
}
